//+------------------------------------------------------------------+
//|                                                 ChartObjects.mq5 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
//---
#property indicator_chart_window //    
#property indicator_plots 0      //    
//---  -
#resource "\\Indicators\\SubWindow.ex5"
//---  -
#define TIMEFRAME_BUTTONS 21
//---     -
#define PROPERTY_BUTTONS 5
//---    SubWindow  
string subwindow_path         ="::Indicators\\SubWindow.ex5";
int    subwindow_number       =-1;               //  
int    subwindow_handle       =INVALID_HANDLE;   //   SubWindow
string subwindow_shortname    ="SubWindow";      //   
//---
int    chart_width            =0;                //  
int    chart_height           =0;                //  
int    chart_scale            =0;                //  
//---
color  cOffButtonFont         =clrWhite;         //     
color  cOffButtonBackground   =clrDarkSlateGray; //     
color  cOffButtonBorder       =clrLightGray;     //     
//---
color  cOnButtonFont          =clrGold;          //     
color  cOnButtonBackground    =C'28,47,47';      //     
color  cOnButtonBorder        =clrLightGray;     //     
//---      -
string timeframe_button_names[TIMEFRAME_BUTTONS]=
  {
   "button_m1","button_m2","button_m3","button_m4","button_m5","button_m6","button_m10",
   "button_m12","button_m15","button_m20","button_m30","button_h1","button_h2","button_h3",
   "button_h4","button_h6","button_h8","button_h12","button_d1","button_w1","button_mn"
  };
//---      -
string timeframe_button_texts[TIMEFRAME_BUTTONS]=
  {
   "M1","M2","M3","M4","M5","M6","M10",
   "M12","M15","M20","M30","H1","H2","H3",
   "H4","H6","H8","H12","D1","W1","MN"
  };
//---   -
bool timeframe_button_states[TIMEFRAME_BUTTONS]={false};

//---        
string property_button_names[PROPERTY_BUTTONS]=
  {
   "property_button_date","property_button_price",
   "property_button_ohlc","property_button_askbid",
   "property_button_trade_levels"
  };
//---        
string property_button_texts[PROPERTY_BUTTONS]=
  {
   "Date","Price","OHLC","Ask / Bid","Trade Levels"
  };
//---     
bool property_button_states[PROPERTY_BUTTONS]={false};

//---     
int property_button_widths[PROPERTY_BUTTONS]=
  {
   66,68,66,100,101
  };

//---    -
string chart_object_names[TIMEFRAME_BUTTONS]=
  {
   "chart_object_m1","chart_object_m2","chart_object_m3","chart_object_m4","chart_object_m5","chart_object_m6","chart_object_m10",
   "chart_object_m12","chart_object_m15","chart_object_m20","chart_object_m30","chart_object_h1","chart_object_h2","chart_object_h3",
   "chart_object_h4","chart_object_h6","chart_object_h8","chart_object_h12","chart_object_d1","chart_object_w1","chart_object_mn"
  };
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---      -
   AddTimeframeButtons();
//---        
   AddPropertyButtons();
//---  
   ChartRedraw();
//---   
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                         |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---     
   if(reason==REASON_REMOVE)
     {
      //---  
      DeleteTimeframeButtons();
      DeletePropertyButtons();
      //---  
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---  CHARTEVENT_OBJECT_CLICK
   if(ChartEventObjectClick(id,lparam,dparam,sparam))
      return;
//---  CHARTEVENT_CHART_CHANGE
   if(ChartEventChartChange(id,lparam,dparam,sparam))
      return;
  }
//+------------------------------------------------------------------+
//|   ""                                          |
//+------------------------------------------------------------------+
void CreateButton(long              chart_id,         // id 
                  int               window_number,    //  
                  string            name,             //  
                  string            text,             //  
                  ENUM_ANCHOR_POINT anchor,           //  
                  ENUM_BASE_CORNER  corner,           //  
                  string            font_name,        // 
                  int               font_size,        //  
                  color             font_color,       //  
                  color             background_color, //  
                  color             border_color,     //  
                  int               x_size,           // 
                  int               y_size,           // 
                  int               x_distance,       //    X
                  int               y_distance,       //    Y
                  long              z_order)          // 
  {
//---    
   if(ObjectCreate(chart_id,name,OBJ_BUTTON,window_number,0,0))
     {
      //   
      ObjectSetString(chart_id,name,OBJPROP_TEXT,text);                  //  
      ObjectSetString(chart_id,name,OBJPROP_FONT,font_name);             //  
      ObjectSetInteger(chart_id,name,OBJPROP_COLOR,font_color);          //   
      ObjectSetInteger(chart_id,name,OBJPROP_BGCOLOR,background_color);  //   
      ObjectSetInteger(chart_id,name,OBJPROP_BORDER_COLOR,border_color); //   
      ObjectSetInteger(chart_id,name,OBJPROP_ANCHOR,anchor);             //   
      ObjectSetInteger(chart_id,name,OBJPROP_CORNER,corner);             //   
      ObjectSetInteger(chart_id,name,OBJPROP_FONTSIZE,font_size);        //   
      ObjectSetInteger(chart_id,name,OBJPROP_XSIZE,x_size);              //  
      ObjectSetInteger(chart_id,name,OBJPROP_YSIZE,y_size);              //  
      ObjectSetInteger(chart_id,name,OBJPROP_XDISTANCE,x_distance);      //   X
      ObjectSetInteger(chart_id,name,OBJPROP_YDISTANCE,y_distance);      //   Y
      ObjectSetInteger(chart_id,name,OBJPROP_SELECTABLE,false);          //    
      ObjectSetInteger(chart_id,name,OBJPROP_STATE,false);               //   (/)
      ObjectSetInteger(chart_id,name,OBJPROP_ZORDER,z_order);            //      
      ObjectSetString(chart_id,name,OBJPROP_TOOLTIP,"\n");               //   
     }
  }
//+------------------------------------------------------------------+
//|   ""                                  |
//+------------------------------------------------------------------+
void CreateChartInSubwindow(int             window_number,  //  
                            int             x_distance,     //  X
                            int             y_distance,     //  Y
                            int             x_size,         // 
                            int             y_size,         // 
                            string          name,           //  
                            string          symbol,         // 
                            ENUM_TIMEFRAMES timeframe,      // 
                            int             subchart_scale, //  
                            bool            show_dates,     //   
                            bool            show_prices,    //   
                            bool            show_ohlc,      //   OHLC
                            bool            show_ask_bid,   //   ask/bid
                            bool            show_levels,    //   
                            string          tooltip)        //  
  {
//---    
   if(ObjectCreate(0,name,OBJ_CHART,window_number,0,0))
     {
      //---   -
      ObjectSetInteger(0,name,OBJPROP_CORNER,CORNER_LEFT_UPPER);   //   
      ObjectSetInteger(0,name,OBJPROP_XDISTANCE,x_distance);       //  X
      ObjectSetInteger(0,name,OBJPROP_YDISTANCE,y_distance);       //  Y
      ObjectSetInteger(0,name,OBJPROP_XSIZE,x_size);               // 
      ObjectSetInteger(0,name,OBJPROP_YSIZE,y_size);               // 
      ObjectSetInteger(0,name,OBJPROP_CHART_SCALE,subchart_scale); //  
      ObjectSetInteger(0,name,OBJPROP_DATE_SCALE,show_dates);      //  
      ObjectSetInteger(0,name,OBJPROP_PRICE_SCALE,show_prices);    //  
      ObjectSetString(0,name,OBJPROP_SYMBOL,symbol);               // 
      ObjectSetInteger(0,name,OBJPROP_PERIOD,timeframe);           // 
      ObjectSetString(0,name,OBJPROP_TOOLTIP,tooltip);             //  
      ObjectSetInteger(0,name,OBJPROP_BACK,false);                 //    
      ObjectSetInteger(0,name,OBJPROP_SELECTABLE,false);           //    
      ObjectSetInteger(0,name,OBJPROP_COLOR,clrWhite);             //  
      //---   -
      long subchart_id=ObjectGetInteger(0,name,OBJPROP_CHART_ID);
      //---    -
      ChartSetInteger(subchart_id,CHART_SHOW_OHLC,show_ohlc);           // OHLC
      ChartSetInteger(subchart_id,CHART_SHOW_TRADE_LEVELS,show_levels); //  
      ChartSetInteger(subchart_id,CHART_SHOW_BID_LINE,show_ask_bid);    //  bid
      ChartSetInteger(subchart_id,CHART_SHOW_ASK_LINE,show_ask_bid);    //  ask
      ChartSetInteger(subchart_id,CHART_COLOR_LAST,clrLimeGreen);       //      
      ChartSetInteger(subchart_id,CHART_COLOR_STOP_LEVEL,clrRed);       //   - 
      //---  -
      ChartRedraw(subchart_id);
     }
  }
//+------------------------------------------------------------------+
//|  -                                      |
//+------------------------------------------------------------------+
void AddTimeframeButtons()
  {
   int x_dist =1;   //     
   int y_dist =125; //     
   int x_size =28;  //  
   int y_size =20;  //  
//---
   for(int i=0; i<TIMEFRAME_BUTTONS; i++)
     {
      //---      7 ,     
      if(i%7==0)
        {
         x_dist=1;
         y_dist-=21;
        }
      //---  -
      CreateButton(0,0,timeframe_button_names[i],timeframe_button_texts[i],
                   ANCHOR_LEFT_LOWER,CORNER_LEFT_LOWER,"Arial",8,
                   cOffButtonFont,cOffButtonBackground,cOffButtonBorder,
                   x_size,y_size,x_dist,y_dist,3);
      //---   X   
      x_dist+=x_size+1;
     }
  }
//+------------------------------------------------------------------+
//|                                   |
//+------------------------------------------------------------------+
void AddPropertyButtons()
  {
   int x_dist =1;  //     
   int y_dist =41; //     
   int x_size =66; //  
   int y_size =20; //  
//---
   for(int i=0; i<PROPERTY_BUTTONS; i++)
     {
      //---      ,     
      if(i==3)
        {
         x_dist=1;
         y_dist-=21;
        }
      //---  
      CreateButton(0,0,property_button_names[i],property_button_texts[i],
                   ANCHOR_LEFT_LOWER,CORNER_LEFT_LOWER,"Arial",8,
                   cOffButtonFont,cOffButtonBackground,cOffButtonBorder,
                   property_button_widths[i],y_size,x_dist,y_dist,3);
      //---   X   
      x_dist+=property_button_widths[i]+1;
     }
  }
//+------------------------------------------------------------------+
//|                                 |
//+------------------------------------------------------------------+
void DeleteTimeframeButtons()
  {
   for(int i=0; i<TIMEFRAME_BUTTONS; i++)
      DeleteObjectByName(timeframe_button_names[i]);
  }
//+------------------------------------------------------------------+
//|   c                         |
//+------------------------------------------------------------------+
void DeletePropertyButtons()
  {
   for(int i=0; i<PROPERTY_BUTTONS; i++)
      DeleteObjectByName(property_button_names[i]);
  }
//+------------------------------------------------------------------+
//|                                             |
//+------------------------------------------------------------------+
void DeleteObjectByName(string object_name)
  {
//---    
   if(ObjectFind(ChartID(),object_name)>=0)
     {
      //---      
      if(!ObjectDelete(ChartID(),object_name))
         Print(" ("+IntegerToString(GetLastError())+")   !");
     }
  }
//+------------------------------------------------------------------+
//|                           |
//+------------------------------------------------------------------+
bool ChartEventObjectClick(int id,
                           long lparam,
                           double dparam,
                           string sparam)
  {
//---     
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      //---    -, /  'SubWindow'  -
      if(ToggleSubwindowAndChartObject(sparam))
         return(true);
      //---      , /   -
      if(ToggleChartObjectProperty(sparam))
         return(true);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
bool ChartEventChartChange(int id,
                           long lparam,
                           double dparam,
                           string sparam)
  {
//---     
   if(id==CHARTEVENT_CHART_CHANGE)
     {
      //---   SubWindow  ( ),    , 
      //        ()
      if(OnSubwindowDelete())
         return(true);
      //---          SubWindow,   
      GetSubwindowWidthAndHeight();
      //---    
      AdjustChartObjectsSizes();
      //---    
      ChartRedraw();
      return(true);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//| /  SubWindow  -          |
//+------------------------------------------------------------------+
bool ToggleSubwindowAndChartObject(string clicked_object_name)
  {
//--- ,      -
   if(CheckClickOnTimeframeButton(clicked_object_name))
     {
      //--- ,    SubWindow
      subwindow_number=ChartWindowFind(0,subwindow_shortname);
      //---    SubWindow,  
      if(subwindow_number<0)
        {
         //---   SubWindow 
         if(AddSubwindow())
           {
            //---    -
            AddChartObjectsToSubwindow(clicked_object_name);
            return(true);
           }
        }
      //---    SubWindow
      if(subwindow_number>0)
        {
         //---    -
         AddChartObjectsToSubwindow(clicked_object_name);
         return(true);
        }
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//| ,     -                  |
//+------------------------------------------------------------------+
bool CheckClickOnTimeframeButton(string clicked_object_name)
  {
//---    -    
   for(int i=0; i<TIMEFRAME_BUTTONS; i++)
     {
      //---   
      if(clicked_object_name==timeframe_button_names[i])
         return(true);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//|     -               |
//+------------------------------------------------------------------+
bool AddSubwindow()
  {
//---    "SubWindow"
   subwindow_handle=iCustom(_Symbol,_Period,subwindow_path);
//---   
   if(subwindow_handle!=INVALID_HANDLE)
     {
      //---        
      subwindow_number=(int)ChartGetInteger(0,CHART_WINDOWS_TOTAL);
      //---   SubWindow  
      if(!ChartIndicatorAdd(0,subwindow_number,subwindow_handle))
         Print("    SubWindow ! ");
      //---  
      else
         return(true);
     }
//---  
   return(false);
  }
//+------------------------------------------------------------------+
//|    -                            |
//+------------------------------------------------------------------+
void DeleteSubwindow()
  {
//---    SubWindow
   if((subwindow_number=ChartWindowFind(0,subwindow_shortname))>0)
     {
      //---  
      if(!ChartIndicatorDelete(0,subwindow_number,subwindow_shortname))
         Print("    "+subwindow_shortname+"!");
     }
  }
//+------------------------------------------------------------------+
//|  -                                |
//+------------------------------------------------------------------+
void AddChartObjectsToSubwindow(string clicked_object_name)
  {
   ENUM_TIMEFRAMES tf                 =WRONG_VALUE; // 
   string          object_name        ="";          //  
   string          object_text        ="";          //   
   int             x_distance         =0;           //    X
   int             total_charts       =0;           //  -
   int             chart_object_width =0;           //  -
//---   , /  SubWindow
   chart_scale=(int)ChartGetInteger(0,CHART_SCALE);
   chart_width=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,subwindow_number);
   chart_height=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,subwindow_number);
//---   -   SubWindow
   total_charts=ObjectsTotal(0,subwindow_number,OBJ_CHART);
//---   -
   if(total_charts==0)
     {
      //--- ,     -
      if(CheckClickOnTimeframeButton(clicked_object_name))
        {
         //---   -
         InitializeTimeframeButtonStates();
         //---    -     -
         object_text=ObjectGetString(0,clicked_object_name,OBJPROP_TEXT);
         //---    -
         tf=StringToTimeframe(object_text);
         //---  -
         CreateChartInSubwindow(subwindow_number,0,0,chart_width,chart_height,
                                "chart_object_"+object_text,_Symbol,tf,chart_scale,
                                property_button_states[0],property_button_states[1],
                                property_button_states[2],property_button_states[3],
                                property_button_states[4],object_text);
         //---    
         ChartRedraw();
         return;
        }
     }
//---  -     SubWindow
   if(total_charts>0)
     {
      //---    -    
      int pressed_buttons_count=InitializeTimeframeButtonStates();
      //---    ,   SubWindow
      if(pressed_buttons_count==0)
         DeleteSubwindow();
      //---    
      else
        {
         //---   -  
         ObjectsDeleteAll(0,subwindow_number,OBJ_CHART);
         //---    -
         chart_object_width=chart_width/pressed_buttons_count;
         //---      
         for(int i=0; i<TIMEFRAME_BUTTONS; i++)
           {
            //---   
            if(timeframe_button_states[i])
              {
               //---    -     -
               object_text=ObjectGetString(0,timeframe_button_names[i],OBJPROP_TEXT);
               //---    -
               tf=StringToTimeframe(object_text);
               //---  -
               CreateChartInSubwindow(subwindow_number,x_distance,0,chart_object_width,chart_height,
                                      chart_object_names[i],_Symbol,tf,chart_scale,
                                      property_button_states[0],property_button_states[1],
                                      property_button_states[2],property_button_states[3],
                                      property_button_states[4],object_text);
               //---   X   -
               x_distance+=chart_object_width;
              }
           }
        }
     }
//---  
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//|    -              |
//|                                 |
//+------------------------------------------------------------------+
int InitializeTimeframeButtonStates()
  {
//---   -
   int pressed_buttons_count=0;
//---    -   
   for(int i=0; i<TIMEFRAME_BUTTONS; i++)
     {
      //---   
      if(ObjectGetInteger(0,timeframe_button_names[i],OBJPROP_STATE))
        {
         //---      
         timeframe_button_states[i]=true;
         //---    
         ObjectSetInteger(0,timeframe_button_names[i],OBJPROP_COLOR,cOnButtonFont);
         ObjectSetInteger(0,timeframe_button_names[i],OBJPROP_BGCOLOR,cOnButtonBackground);
         //---    
         pressed_buttons_count++;
        }
      else
        {
         //---    
         ObjectSetInteger(0,timeframe_button_names[i],OBJPROP_COLOR,cOffButtonFont);
         ObjectSetInteger(0,timeframe_button_names[i],OBJPROP_BGCOLOR,cOffButtonBackground);
         //--- ,    
         timeframe_button_states[i]=false;
        }
     }
//---    
   return(pressed_buttons_count);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
ENUM_TIMEFRAMES StringToTimeframe(string timeframe)
  {
   StringToUpper(timeframe);
//---
   if(timeframe=="M1")  return(PERIOD_M1);
   if(timeframe=="M2")  return(PERIOD_M2);
   if(timeframe=="M3")  return(PERIOD_M3);
   if(timeframe=="M4")  return(PERIOD_M4);
   if(timeframe=="M5")  return(PERIOD_M5);
   if(timeframe=="M6")  return(PERIOD_M6);
   if(timeframe=="M10") return(PERIOD_M10);
   if(timeframe=="M12") return(PERIOD_M12);
   if(timeframe=="M15") return(PERIOD_M15);
   if(timeframe=="M20") return(PERIOD_M20);
   if(timeframe=="M30") return(PERIOD_M30);
   if(timeframe=="H1")  return(PERIOD_H1);
   if(timeframe=="H2")  return(PERIOD_H2);
   if(timeframe=="H3")  return(PERIOD_H3);
   if(timeframe=="H4")  return(PERIOD_H4);
   if(timeframe=="H6")  return(PERIOD_H6);
   if(timeframe=="H8")  return(PERIOD_H8);
   if(timeframe=="H12") return(PERIOD_H12);
   if(timeframe=="D1")  return(PERIOD_D1);
   if(timeframe=="W1")  return(PERIOD_W1);
   if(timeframe=="MN")  return(PERIOD_MN1);
//---
   return(WRONG_VALUE);
  }
//+------------------------------------------------------------------+
//| /  -                   |
//|                              |
//+------------------------------------------------------------------+
bool ToggleChartObjectProperty(string clicked_object_name)
  {

//---     "Date"
   if(clicked_object_name=="property_button_date")
     {
      //---   
      if(SetButtonColor(clicked_object_name))
         ShowDate(true);
      //---   
      else
         ShowDate(false);
      //---    
      ChartRedraw();
      return(true);
     }
//---     Price
   if(clicked_object_name=="property_button_price")
     {
      //---   
      if(SetButtonColor(clicked_object_name))
         ShowPrice(true);
      //---   
      else
         ShowPrice(false);
      //---    
      ChartRedraw();
      return(true);
     }
//---     OHLC
   if(clicked_object_name=="property_button_ohlc")
     {
      //---   
      if(SetButtonColor(clicked_object_name))
         ShowOHLC(true);
      //---   
      else
         ShowOHLC(false);
      //---    
      ChartRedraw();
      return(true);
     }
//---     Ask/Bid
   if(clicked_object_name=="property_button_askbid")
     {
      //---   
      if(SetButtonColor(clicked_object_name))
         ShowAskBid(true);
      //---   
      else
         ShowAskBid(false);
      //---    
      ChartRedraw();
      return(true);
     }
//---     Trade Levels
   if(clicked_object_name=="property_button_trade_levels")
     {
      //---   
      if(SetButtonColor(clicked_object_name))
         ShowTradeLevels(true);
      //---   
      else
         ShowTradeLevels(false);
      //---    
      ChartRedraw();
      return(true);
     }
//---  
   return(false);
  }
//+------------------------------------------------------------------+
//|           |
//+------------------------------------------------------------------+
bool SetButtonColor(string clicked_object_name)
  {
//---   
   if(ObjectGetInteger(0,clicked_object_name,OBJPROP_STATE))
     {
      //---    
      ObjectSetInteger(0,clicked_object_name,OBJPROP_COLOR,cOnButtonFont);
      ObjectSetInteger(0,clicked_object_name,OBJPROP_BGCOLOR,cOnButtonBackground);
      return(true);
     }
//---   
   if(!ObjectGetInteger(0,clicked_object_name,OBJPROP_STATE))
     {
      //---    
      ObjectSetInteger(0,clicked_object_name,OBJPROP_COLOR,cOffButtonFont);
      ObjectSetInteger(0,clicked_object_name,OBJPROP_BGCOLOR,cOffButtonBackground);
      return(false);
     }
//---
   return(false);
  }
//+------------------------------------------------------------------+
//| /                      |
//+------------------------------------------------------------------+
void ShowDate(bool state)
  {
   int    total_charts=0;  //  
   string chart_name  =""; //  -
//--- ,    SubWindow
//     , ...
   if((subwindow_number=ChartWindowFind(0,subwindow_shortname))>0)
     {
      //---  - -
      total_charts=ObjectsTotal(0,subwindow_number,OBJ_CHART);
      //---      -
      for(int i=0; i<total_charts; i++)
        {
         //---   -
         chart_name=ObjectName(0,i,subwindow_number,OBJ_CHART);
         //---  
         ObjectSetInteger(0,chart_name,OBJPROP_DATE_SCALE,state);
        }
      //---      
      if(state)
         property_button_states[0]=true;
      else
         property_button_states[0]=false;
      //---  
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//| /                      |
//+------------------------------------------------------------------+
void ShowPrice(bool state)
  {
   int    total_charts=0;  //  
   string chart_name  =""; //  -
//--- ,    SubWindow
//     , ...
   if((subwindow_number=ChartWindowFind(0,subwindow_shortname))>0)
     {
      //---  -  
      total_charts=ObjectsTotal(0,subwindow_number,OBJ_CHART);
      //---      -
      for(int i=0; i<total_charts; i++)
        {
         //---   -
         chart_name=ObjectName(0,i,subwindow_number,OBJ_CHART);
         //---  
         ObjectSetInteger(0,chart_name,OBJPROP_PRICE_SCALE,state);
        }
      //---      
      if(state)
         property_button_states[1]=true;
      else
         property_button_states[1]=false;
      //---  
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//| / OHLC                     |
//+------------------------------------------------------------------+
void ShowOHLC(bool state)
  {
   int    total_charts=0;  //  
   long   subchart_id =0;  //  -
   string chart_name  =""; //  -
//--- ,    SubWindow
//     , ...
   if((subwindow_number=ChartWindowFind(0,subwindow_shortname))>0)
     {
      //---  -  
      total_charts=ObjectsTotal(0,subwindow_number,OBJ_CHART);
      //---      -
      for(int i=0; i<total_charts; i++)
        {
         //---   -
         chart_name=ObjectName(0,i,subwindow_number,OBJ_CHART);
         //---   -
         subchart_id=ObjectGetInteger(0,chart_name,OBJPROP_CHART_ID);
         //---  
         ChartSetInteger(subchart_id,CHART_SHOW_OHLC,state);
         //---  -
         ChartRedraw(subchart_id);
        }
      //---      
      if(state)
         property_button_states[2]=true;
      else
         property_button_states[2]=false;
      //---  
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//| /  Ask/Bid           |
//+------------------------------------------------------------------+
void ShowAskBid(bool state)
  {
   int    total_charts=0;  //  
   long   subchart_id =0;  //  -
   string chart_name  =""; //  -
//--- ,    SubWindow
//     , ...
   if((subwindow_number=ChartWindowFind(0,subwindow_shortname))>0)
     {
      //---  -  
      total_charts=ObjectsTotal(0,subwindow_number,OBJ_CHART);
      //---      -
      for(int i=0; i<total_charts; i++)
        {
         //---   -
         chart_name=ObjectName(0,i,subwindow_number,OBJ_CHART);
         //---   -
         subchart_id=ObjectGetInteger(0,chart_name,OBJPROP_CHART_ID);
         //---  
         ChartSetInteger(subchart_id,CHART_SHOW_ASK_LINE,state);
         ChartSetInteger(subchart_id,CHART_SHOW_BID_LINE,state);
         //---  -
         ChartRedraw(subchart_id);
        }
      //---      
      if(state)
         property_button_states[3]=true;
      else
         property_button_states[3]=false;
      //---  
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//| /            |
//+------------------------------------------------------------------+
void ShowTradeLevels(bool state)
  {
   int    total_charts=0;  //  
   long   subchart_id =0;  //  -
   string chart_name  =""; //  -
//--- ,    SubWindow
//     , ...
   if((subwindow_number=ChartWindowFind(0,subwindow_shortname))>0)
     {
      //---  -  
      total_charts=ObjectsTotal(0,subwindow_number,OBJ_CHART);
      //---      -
      for(int i=0; i<total_charts; i++)
        {
         //---   -
         chart_name=ObjectName(0,i,subwindow_number,OBJ_CHART);
         //---   -
         subchart_id=ObjectGetInteger(0,chart_name,OBJPROP_CHART_ID);
         //---  
         ChartSetInteger(subchart_id,CHART_SHOW_TRADE_LEVELS,state);
         //---  -
         ChartRedraw(subchart_id);
        }
      //---      
      if(state)
         property_button_states[4]=true;
      else
         property_button_states[4]=false;
      //---  
      ChartRedraw();
     }
  }
//+------------------------------------------------------------------+
//|     Subwindow                            |
//+------------------------------------------------------------------+
bool OnSubwindowDelete()
  {
//---   SubWindow 
   if(ChartWindowFind(0,subwindow_shortname)<1)
     {
      //---    -
      AddTimeframeButtons();
      ChartRedraw();
      return(true);
     }
//---  SubWindow 
   return(false);
  }
//+------------------------------------------------------------------+
//|       SubWindow             |
//+------------------------------------------------------------------+
void GetSubwindowWidthAndHeight()
  {
//--- ,      SubWindow
   if((subwindow_number=ChartWindowFind(0,subwindow_shortname))>0)
     {
      //     
      chart_height=(int)ChartGetInteger(0,CHART_HEIGHT_IN_PIXELS,subwindow_number);
      chart_width=(int)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS,subwindow_number);
     }
  }
//+------------------------------------------------------------------+
//|   -        |
//+------------------------------------------------------------------+
void AdjustChartObjectsSizes()
  {
   int             x_distance         =0;           //    X
   int             total_objects      =0;           //  -
   int             chart_object_width =0;           //  -
   string          object_name        ="";          //  
   ENUM_TIMEFRAMES TF                 =WRONG_VALUE; // 
//---    SubWindow
   if((subwindow_number=ChartWindowFind(0,subwindow_shortname))>0)
     {
      //---    -
      total_objects=ObjectsTotal(0,subwindow_number,OBJ_CHART);
      //---   ,     
      if(total_objects==0)
        {
         DeleteSubwindow();
         return;
        }
      //---    -
      chart_object_width=chart_width/total_objects;
      //---      -
      for(int i=total_objects-1; i>=0; i--)
        {
         //---  
         object_name=ObjectName(0,i,subwindow_number,OBJ_CHART);
         //---     -
         ObjectSetInteger(0,object_name,OBJPROP_YSIZE,chart_height);
         ObjectSetInteger(0,object_name,OBJPROP_XSIZE,chart_object_width);
         //---   -
         ObjectSetInteger(0,object_name,OBJPROP_YDISTANCE,0);
         ObjectSetInteger(0,object_name,OBJPROP_XDISTANCE,x_distance);
         //---      X   -
         x_distance+=chart_object_width;
        }
     }
  }
//+------------------------------------------------------------------+
